/*
   prog5-4.cpp

   En enkel klass fr klockslag, nu med std fr ut- och inmatning 
   via iostream.

*/

#include <iostream.h>

class time
{
   private:

      int h, m;

   public:

      // konstruktor med frvalda argument
      time(int = 0, int = 0);

      // ndra klockslag
      void set(int, int);

      // hmta minut
      int getminute() const { return m; }

      // hmta timme
      int gethour() const { return h; }

      // skriv ut klockslag
      friend ostream& operator<<(ostream&,const time&);

      // mata in klockslag
      friend istream& operator>>(istream&,time&);
};

// konstruktor
time::time(int hour, int minute)
{
   h = hour;
   m = minute;
}

// ndra klockslag
void time::set(int hour, int minute)
{
   h = hour;
   m = minute;
}

// skriv ut klockslag
ostream& operator<<(ostream& o,const time& t)
{
   // mata ut timme och tecknet ':'
   o << t.gethour() << ':';
   
   // fr att gra utmatningen lite snyggare, anvnder vi
   // medlemsfunktionerna width och fill s att minuterna
   // alltid skrivs ut med tv siffror och fylls ut med 
   // nollor (gr att 12:00 skrivs ut istllet fr 12:0).
   o.width(2);
   o.fill('0');

   // mata ut minut
   return o << t.getminute();
}

// mata in klockslag
istream& operator>>(istream& i,time& t)
{
   char c;

   // ls in timme
   i >> t.h; 

   // ls in separationstecken (':' eller '.')
   i >> c; 

   // ls in minut
   return i >> t.m; 
}

// testa klassen time
main()
{
   time in,lunch,back,out;

   cout << "Ange dina tider (hh:mm):\n";
   cout << "In>       ";
   cin >> in;
   cout << "Lunch>    ";
   cin >> lunch;
   cout << "Tillbaka> "; 
   cin >> back;
   cout << "Ut>       ";
   cin >> out;
   cout << "Jaha, du kom " << in << ", hade lunch mellan " << lunch;
   cout << " och " << back << ", och gick klockan " << out << ".\n";
   cout << "Kallar du det en arbetsdag?\n";

   return 0;
}

